#include <windows.h>
#include "Expand.h"

#define	NEARTAG		0xa7
#define	FARTAG		0xa8

VOID CExpand::CarmackExpand (USHORT* source, USHORT* dest, USHORT length)
{
	USHORT ch, chhigh, count, offset;
	USHORT *copyptr, *inptr, *outptr;
	LPBYTE lpInc;

	length /= 2;

	inptr = source;
	outptr = dest;

	while(length)
	{
		ch = *inptr++;
		chhigh = ch>>8;
		if (chhigh == NEARTAG)
		{
			count = ch & 0xff;
			if (!count)
			{				// have to insert a word containing the tag byte
				ch |= *((LPBYTE)inptr);
				//
				lpInc = (LPBYTE)inptr;
				lpInc++;
				inptr = (USHORT*)lpInc;
				//
				*outptr++ = ch;
				length--;
			}
			else
			{
				offset = *((LPBYTE)inptr);
				//
				lpInc = (LPBYTE)inptr;
				lpInc++;
				inptr = (USHORT*)lpInc;
				//
				copyptr = outptr - offset;
				length -= count;
				while (count--)
					*outptr++ = *copyptr++;
			}
		}
		else if (chhigh == FARTAG)
		{
			count = ch&0xff;
			if (!count)
			{				// have to insert a word containing the tag byte
				ch |= *((LPBYTE)inptr);
				//
				lpInc = (LPBYTE)inptr;
				lpInc++;
				inptr = (USHORT*)lpInc;
				//
				*outptr++ = ch;
				length --;
			}
			else
			{
				offset = *inptr++;
				copyptr = dest + offset;
				length -= count;
				while (count--)
					*outptr++ = *copyptr++;
			}
		}
		else
		{
			*outptr++ = ch;
			length --;
		}
	}
}

VOID CExpand::RLEWexpand (USHORT* source, USHORT* dest, LONG length, USHORT rlewtag)
{
	USHORT value, count, i;
	USHORT* end = dest + (length)/2;

	do
	{
		value = *source++;
		if(value != rlewtag)
			*dest++ = value;
		else
		{
			count = *source++;
			value = *source++;
			for(i = 1; i <= count; i++)
				*dest++ = value;
		}
	} while(dest < end);
}