#include "MapConvert.h"

class CMapLine
{
public:
	VERTEX m_vFrom;
	VERTEX m_vTo;
	SHORT m_Flags;
	SHORT m_Types;
	SHORT m_Tag;
	SIDEDEF m_sRight;
	SIDEDEF m_sLeft;
	BYTE m_Special;
	BYTE m_Args[5];

public:
	CMapLine (CMapLine* lpLine);
	CMapLine (LPMAPLINE1 lpLine1);
	CMapLine (LPMAPLINE2 lpLine2);
	CMapLine ();
	~CMapLine ();

	VOID Reset (VOID);

	VOID operator= (CMapLine& Line);

	LPMAPLINE1 GetMapLine1 (LPMAPLINE1 lpLine1);
	LPMAPLINE2 GetMapLine2 (LPMAPLINE2 lpLine2);
};