#include <windows.h>
#include "MapThing.h"

CMapThing::CMapThing (CMapThing* lpThing)
{
	*this = *lpThing;
}

CMapThing::CMapThing (LPTHING1 lpThing1)
{
	m_ID = 0;
	m_x = lpThing1->x;
	m_y = lpThing1->y;
	m_z = 0;
	m_Angle = lpThing1->Angle;
	m_Type = lpThing1->Type;
	m_Options = lpThing1->Options;
	m_Special = 0;
	ZeroMemory(m_Args,sizeof(m_Args));
}

CMapThing::CMapThing (LPTHING2 lpThing2)
{
	m_ID = lpThing2->ID;
	m_x = lpThing2->x;
	m_y = lpThing2->y;
	m_z = lpThing2->z;
	m_Angle = lpThing2->Angle;
	m_Type = lpThing2->Type;
	m_Options = lpThing2->Options;
	m_Special = lpThing2->Special;
	CopyMemory(m_Args,lpThing2->Args,sizeof(m_Args));
}

CMapThing::CMapThing ()
{
	Reset();
}

CMapThing::~CMapThing ()
{
}

VOID CMapThing::Reset (VOID)
{
	m_ID = 0;
	m_x = 0;
	m_y = 0;
	m_z = 0;
	m_Angle = 0;
	m_Type = 0;
	m_Options = 0;
	m_Special = 0;
	ZeroMemory(m_Args,sizeof(m_Args));
}

VOID CMapThing::operator= (CMapThing& Thing)
{
	m_ID = Thing.m_ID;
	m_x = Thing.m_x;
	m_y = Thing.m_y;
	m_z = Thing.m_z;
	m_Angle = Thing.m_Angle;
	m_Type = Thing.m_Type;
	m_Options = Thing.m_Options;
	m_Special = Thing.m_Special;
	CopyMemory(m_Args,Thing.m_Args,sizeof(m_Args));
}

LPTHING1 CMapThing::GetMapThing1 (LPTHING1 lpThing1)
{
	lpThing1->x = m_x;
	lpThing1->y = m_y;
	lpThing1->Angle = m_Angle;
	lpThing1->Type = m_Type;
	lpThing1->Options = m_Options;
	return lpThing1;
}

LPTHING2 CMapThing::GetMapThing2 (LPTHING2 lpThing2)
{
	lpThing2->ID = m_ID;
	lpThing2->x = m_x;
	lpThing2->y = m_y;
	lpThing2->z = m_z;
	lpThing2->Angle = m_Angle;
	lpThing2->Type = m_Type;
	lpThing2->Options = m_Options;
	lpThing2->Special = m_Special;
	CopyMemory(lpThing2->Args,m_Args,sizeof(m_Args));
	return lpThing2;
}